This is intented to hold all the map code.

> module Map where
> import Array
> import List

> data Direction = North
>                | South
>                | East
>                | West
>     deriving (Show,Eq)

> opposite North = South
> opposite South = North
> opposite East = West
> opposite West = East

> type Position = (Int, Int)

> deltaDir dir = case dir of
>	 North -> (0,1)
>	 South -> (0,(-1))
>	 East -> (1,0)
>	 West -> ((-1),0)

> move dir (x,y) = (x+dx,y+dy)
>     where (dx,dy)=deltaDir dir

> data Floor = Wall 
>            | Plain
>            | Water
>            | Base
>     deriving (Show, Eq)

> type Map = Array (Int, Int) Floor

> inside a (x,y) = 0<x && x<=mx && 0<y && y<=my
>    where (_,(mx,my)) = bounds a

> floorAt a p = if inside a p then a!p else Wall

> mapFromString::String->Map
> mapFromString s = mapFromLines (lines s)

> mapFromLines::[String]->Map
> mapFromLines s = array ((1,1),(mx,my)) 
>                         [( (i,j),convert ((s!!(j-1))!!(i-1)) ) | i<-[1..mx],
>                                                                  j<-[1..my]]
>    where mx = (length (head s))
>          my = length s
>          convert c = case c of
>                             '.' -> Plain
>                             '~' -> Water
>                             '#' -> Wall
>                             '@' -> Base

> showMap :: Map -> String
> showMap m =  unlines [(showline i) | i<-[my,(my-1)..1]]
>  where ((_,_),(mx,my)) = bounds m
>        showline i = [(showpoint j i) | j<-[1..mx]]
>        showpoint i j = case m!(i,j) of 
>                            Plain -> '.'
>                            Water -> '~'
>                            Wall -> '#'
>                            Base -> '@'

> exampleMap = mapFromLines  ["....@",
>                             "...~.",
>                             "..#..",
>                             "....."]

> findBases :: Map -> [Position]
> findBases m = concat [findBasesLine i | i<-[1..my]]
>     where findBasesLine j = [(i,j) | i<-[1..mx], (floorAt m (i,j))==Base]
>	    (_,(mx,my)) = bounds m
