> module Robot where

-- > import List
-- > import Array

> import Map



-- > data Direction = North
-- >                | South
-- >                | East
-- >                | West
-- >     deriving Show

-- > type Position = (Int, Int)

-- > move dir (x,y) = case dir of 
-- >                         North -> (x, y+1)
-- >                         South -> (x, y-1)
-- >                         East  -> (x+1, y)
-- >                         West  -> (x-1, y)

-- 

-- > data Floor = Wall 
-- >            | Plain
-- >            | Water
-- >            | Base
-- >     deriving Show

-- > type Map = Array (Int, Int) Floor

-- > inside a (x,y) = 0<x && x<=mx && 0<y && y<=my
-- >    where (_,(mx,my)) = bounds a

-- > floorAt a p = if inside a p then a!p else Wall

-- > mapFromString::String->Map
-- > mapFromString s = array ((1,1),(mx,my)) 
-- >                         [( (i,j),convert (s!!(i-1+(mx+1)*(j-1))) ) | i<-[1..mx],
-- >                                                             j<-[1..my]]
-- >    where mx = case elemIndex '\n' s of Just x  -> x
-- >                                        Nothing -> error "No newline found!"
-- >          my = (length s) `div` (mx+1)
-- >          convert c = case c of
-- >                             '.' -> Plain
-- >                             '~' -> Water
-- >                             '#' -> Wall
-- >                             '@' -> Base

-- > mapFromLines::[String]->Map
-- > mapFromLines s = array ((1,1),(mx,my)) 
-- >                         [( (i,j),convert ((s!!(j-1))!!(i-1)) ) | i<-[1..mx],
-- >                                                                  j<-[1..my]]
-- >    where mx = (length (head s))-1
-- >          my = length s
-- >          convert c = case c of
-- >                             '.' -> Plain
-- >                             '~' -> Water
-- >                             '#' -> Wall
-- >                             '@' -> Base



-- > showMap :: Map -> String
-- > showMap m =  unlines [(showline i) | i<-[my,(my-1)..1]]
-- >  where ((_,_),(mx,my)) = bounds m
-- >        showline i = [(showpoint j i) | j<-[1..mx]]
-- >        showpoint i j = case m!(i,j) of 
-- >                            Plain -> '.'
-- >                            Water -> '~'
-- >                            Wall -> '#'
-- >                            Base -> '@'

-- > exampleMap = mapFromLines  ["....@\n",
-- >                             "..~..\n",
-- >                             "..#..\n",
-- >                             ".....\n"]



-- > data Package = Package Int Position Int
-- >    deriving Show
-- > instance Eq Package where
-- >     (Package id _ _) == (Package id2 _ _) = id == id2
-- > packageId (Package i _ _) = i
-- > destination (Package _ p _) = p
-- > weight (Package _ _ w) = w

-- > examplePackage = Package 1 (1,1) 50



-- > data Robot = Robot Int Position Int [Package] Int
-- >    deriving Show
-- > instance Eq Robot where
-- >    r1 == r2 = (robotId r1) == (robotId r2)
-- > charge (Robot i p m l cp) c = if r>=0 then Just (Robot i p r l cp) else Nothing
-- >     where r = m-c
-- > pickupPackage::Robot->Package->Robot
-- > pickupPackage (Robot i pos money l cp) p = Robot i pos money (p:l) cp

-- > robotPosition (Robot _ pos _ _ _) = pos
-- > robotId (Robot i _ _ _ _) = i
-- > robotPackages (Robot _ _ _ p _) = p
-- > availableCapacity (Robot _ _ _ pl cp) = cp-(foldl (+) 0 (map weight pl))

-- > pickRobot::Int->[Robot]->(Robot,[Robot])
-- > pickRobot i rl = (head [r | r<-rl, (robotId r)==i], [r | r<-rl, (robotId r)/=i])

-- > exampleRobot = Robot 1 (5,1) 1000 [examplePackage] 60



> data RobotCommand = Move Int Int Direction
>                   | Pick Int Int [Int]
>                   | Drop Int Int [Int]
>    deriving Show
> commandRobotId (Move _ i _) = i
> commandRobotId (Pick _ i _) = i
> commandRobotId (Drop _ i _) = i



> data ServerEvent = RobotMoved Int Direction
>                  | RobotPickedUp Int Int
>                  | RobotDropped Int Int
>                  | RobotSentTo Int Position
>                  | RobotAlive Int
>     deriving (Show,Eq)
