
> module SimpleRobot where
> import GameState
> import Robot
> import Map
> import Paths
> import Array
> import Communication
> import RobotAlgos
> import List
> import Maybe
> import Debug.Trace

The algorithm:

Goals: 
 - Kill robot to <dir>
 - Deliver package <id>
 - Go pick up known package <id>
 - Go looking for packages on home base (x,y)
 - Find a robot with a package.

Take the frst goal that's possible

Deliver nearest package first

Visit nearest home base first

> data Goal = Kill Direction
>           | Deliver Int
>           | Fetch Position
>           | Seek Position
>           | PickUp [Int]
>           | DropOff
>           | BeatUp Position
>           | Wait

> initSimpleRobot::Map->(Int,Int,Int)->GameState
> initSimpleRobot map (id,cap,funds) = GameState map
>                                                [] -- no known packages
>                                                [] -- no known robots (not even us! whee!)
>                                                funds
>                                                cap
>                                                id
>                                                (findBases map)
>                                                [] -- no known living robots
>                                                0 -- score is zero initially

> type Evaluator = Paths->GameState->[Goal]->Goal

> doRobot::Evaluator->GameState->[ServerEvent]->[(Int,Position,Int)]->(GameState, RobotCommand)
> doRobot pickGoal g events pkgs = (gf'', cmd)
>     where gf' = flushDeadRobots $
>                 learnPackages (foldl updateGameState g events) pkgs
>	    gf = removeBaseHere gf' (myPosition gf')
>           gf'' = addMoney gf (-(cost cmd))
>           cost (Move b _ _) = abs b
>           cost (Pick b _ _) = abs b
>           cost (Drop b _ _) = abs b
>           myid = getId gf
>           mypos = myPosition gf
>           paths = findPaths (wallsFromMap (getMap gf)) mypos
>           cmd = case pickGoal paths gf (possibleActions paths gf) of
>                   Kill d -> Move 50 myid d
>                   Deliver pid -> Move highValue myid (fromJust $ directionTo paths (fromJust $ packageDest (getPackageData gf pid)))
>                   Fetch p -> Move highValue myid (fromJust $ directionTo paths p)
>                   Seek p -> Move highValue myid (fromJust $ directionTo paths p)
>                   PickUp l -> Pick highValue myid l
>                   DropOff -> Drop highValue myid [p | p<-myPackages gf, packageDest (getPackageData gf p) == Just mypos]
>		    BeatUp p -> Move highValue myid (fromJust $ directionTo paths p)
>                   Wait -> Pick 1 myid []
>	    highValue = if (whoCanPushMe gf myid)==[] then 1 else 50 

FIXME: we don't keep track of money.  Fortunately, we don't care about
money.






This should kill the most optimal robot if there is a choice. 
But it doesn't yet.

> optimalDeliver paths 
>    p1@(PackageData _ (Just d1) _ _) 
>    p2@(PackageData _ (Just d2) _ _) =
>      case (distanceTo paths d1) of
>	    Nothing -> LT
>	    (Just len1) -> case (distanceTo paths d2) of
>		           Nothing -> GT
>		           (Just len2) -> if len1 < len2 then GT else LT
> optimalDeliver _ (PackageData _ Nothing _ _) _ = LT
> optimalDeliver _ _ (PackageData _ Nothing _ _) = GT

> optimalRetrieve paths
>    p1@(PackageData _ _ _ (PackageOnFloor d1))
>    p2@(PackageData _ _ _ (PackageOnFloor d2)) =
>      case (distanceTo paths d1) of
>          Nothing -> LT
>          (Just len1) -> case (distanceTo paths d2) of
>                        Nothing -> GT
>			 (Just len2) -> if len1 < len2 then GT else LT
> optimalRetrieve _ (PackageData _ _ _ (PackageOnFloor _)) _ = GT
> optimalRetrieve _ _ (PackageData _ _ _ (PackageOnFloor _)) = LT
> optimalRetrieve _ _ _ = GT

> optimalBases paths d1 d2 =
>      case (distanceTo paths d1) of
>          Nothing -> LT
>          (Just len1) -> case (distanceTo paths d2) of
>                        Nothing -> GT
>                        (Just len2) -> if len1 < len2 then GT else LT

> optimalBot paths (RobotData _ d1) (RobotData _ d2) =
>      case (distanceTo paths d1) of
>          Nothing -> LT
>          (Just len1) -> case (distanceTo paths d2) of
>                        Nothing -> GT
>                        (Just len2) -> if len1 < len2 then GT else LT

> optimalPickup paths (PackageData _ (Just d1) (Just w1) _) (PackageData _ (Just d2) (Just w2) _) =
>     if w1/=w2 then compare w1 w2
>     else if distanceTo paths d1 < distanceTo paths d2 then GT else LT
> bestPickup paths packages capacity = best (sortBy (optimalPickup paths) packages) capacity
>     where best [] _ = []
>           best (x:xs) c = if (wt x) > c then best xs c
>                           else x:best xs (c-(wt x))
>           wt (PackageData _ _ (Just w) _) = w

-- > pickGoal paths g@(GameState m psr _ _ _ id bases _) = 
-- >     if paksForHere then DropOff
-- >     else if killable/=[] then Kill killDir
-- >     else if paksHere/=[] && bestPackages/=[] then PickUp bestPackages
-- >     else if myPak/=[] && (distanceTo paths dp)/=Nothing then Deliver did
-- >     else if ps/=[] && (isJust rpl) && 
-- >             (distanceTo paths (fromJust rpl))/=Nothing
-- >	   then Fetch (fromJust rpl)
-- >     else if bases/=[] && (distanceTo paths bestBase)/=Nothing then Seek bestBase
-- >     else case (headHunt g paths) of

-- >	   Just (RobotData _ dest) -> BeatUp dest
-- >          Nothing -> Wait -- bored now, let's improve our average CPU time
-- >    where killable = whoCanIKill g id
-- >	   (killHim,killDir) = head killable

-- >          myPak = myPackages g
-- >	   myPos = myPosition g

-- >	   paksForHere = any (\pk-> (packageDest (getPackageData g pk))==(Just myPos)) myPak

-- >	   (PackageData did (Just dp) _ _) =
-- >               maximumBy (optimalDeliver paths) (map (getPackageData g) myPak)

-- >	   bestBase = maximumBy (optimalBases paths) bases

-- Pull out the best packages to pick up (if any).  This list will always
-- be carryable.

-- >          paksHere = packagesAt g myPos
-- >          bestPackages = map packageId $
-- >                         bestPickup paths (map (getPackageData g) paksHere) cap
-- >          cap = availableCapacity g

-- If there is a package that we can't carry, even by itself, we
-- might keep chasing after it to the exclusion of packages that we can
-- carry.  Packages that are known to be too heavy to carry probably need
-- special treatment.  In particular, when we're making the list of known
-- packages we might chase, we should eliminate the ones heavier than our
-- available capacity at the same time as we eliminate the ones that are
-- being carried.

-- >          ps = filter usefulPackage psr
-- >          usefulPackage (PackageData _ _ _ (PackageInRobot _)) = False
-- >          usefulPackage (PackageData _ _ (Just w) _) | w>cap = False
-- >          usefulPackage _ = True

-- Of the useful packages, pick the nearest one. 

-- >          (PackageData rid _ _ rp) = maximumBy (optimalRetrieve paths) ps
-- >          rpl = case rp of (PackageOnFloor l) -> Just l
-- >			    (PackageInRobot _) -> Nothing

> headHunt g@(GameState _ ps rs _ _ _ _ _ _) paths =
>     if null huntableBots then Nothing
>     else Just target
>  where
>     cap = availableCapacity g
>     pkgFilter (PackageData _ _ Nothing _) = True
>     pkgFilter (PackageData _ _ (Just w) _) = w <= cap     
>     huntableBots = (filter 
>	      (\r -> (any pkgFilter 
>	        (map (getPackageData g) (packagesWith g (robotId r)))))
>	      rs)
>     target = maximumBy (optimalBot paths) huntableBots



Look at all the things we might want to do thius turn.
 
> possibleActions paths g@(GameState m psr _ _ _ id bases _ _) = 
>     (if paksForHere then [DropOff] else []) ++
>     (if killable/=[] then [Kill killDir] else []) ++
>     (if paksHere/=[] && bestPackages/=[] then [PickUp bestPackages] else []) ++
>     (if myPak/=[] && (distanceTo paths dp)/=Nothing then [Deliver did] else []) ++
>     (if ps/=[] && (isJust rpl) && (distanceTo paths (fromJust rpl))/=Nothing
>      then [Fetch (fromJust rpl)] else []) ++
>     (if bases/=[] && (distanceTo paths bestBase)/=Nothing then [Seek bestBase] else []) ++
>     (case (headHunt g paths) of

>	   Just (RobotData _ dest) -> [BeatUp dest]
>          Nothing -> []) ++
>     [Wait] -- bored now, let's improve our average CPU time
>    where killable = whoCanIKill g id
>	   (killHim,killDir) = head killable

>          myPak = myPackages g
>	   myPos = myPosition g

>	   paksForHere = any (\pk-> (packageDest (getPackageData g pk))==(Just myPos)) myPak

>	   (PackageData did (Just dp) _ _) =
>               maximumBy (optimalDeliver paths) (map (getPackageData g) myPak)

>	   bestBase = maximumBy (optimalBases paths) bases

Pull out the best packages to pick up (if any).  This list will always
be carryable.

>          paksHere = packagesAt g myPos
>          bestPackages = map packageId $
>                         bestPickup paths (map (getPackageData g) paksHere) cap
>          cap = availableCapacity g

If there is a package that we can't carry, even by itself, we
might keep chasing after it to the exclusion of packages that we can
carry.  Packages that are known to be too heavy to carry probably need
special treatment.  In particular, when we're making the list of known
packages we might chase, we should eliminate the ones heavier than our
available capacity at the same time as we eliminate the ones that are
being carried.

>          ps = filter usefulPackage psr
>          usefulPackage (PackageData _ _ _ (PackageInRobot _)) = False
>          usefulPackage (PackageData _ _ (Just w) _) | w>cap = False
>          usefulPackage _ = True

Of the useful packages, pick the nearest one. 

>          (PackageData rid _ _ rp) = maximumBy (optimalRetrieve paths) ps
>          rpl = case rp of (PackageOnFloor l) -> Just l
>			    (PackageInRobot _) -> Nothing



> simpleChooseAction::Evaluator
> simpleChooseAction paths g l = head l

> simpleRobot = (initSimpleRobot, doRobot simpleChooseAction, describe)



> prioChooseAction::Evaluator
> prioChooseAction paths g actions = action
>     where (value,action) = maximumBy (\ (v1,_) (v2,_) -> compare v2 v1) 
>                                      (map (\ x->(evaluate x,x)) actions)
>           evaluate::Goal->(Int,Int)
>           evaluate DropOff = (0,0)
>           evaluate (Kill _) = (1,0)
>           evaluate (PickUp _) = (2,0)
>           evaluate (Deliver i) = (3, 1*(fromJust $ distanceTo paths (fromJust $ packageDest $ getPackageData g i)))
>           evaluate (Fetch p) = (3, 2*(fromJust $ distanceTo paths p))
>           evaluate (Seek p) = (3, 3*(fromJust $ distanceTo paths p))
>           evaluate (BeatUp p) = (4, 1*(fromJust $ distanceTo paths p))
>           evaluate Wait = (5, 0)

> prioRobot = (initSimpleRobot, doRobot prioChooseAction, describe)
